package.path = package.path .. ";/opt/nevisproxy/webapp/WEB-INF/lib/lua/Utils.lua"
local Utils = require "Utils"

function inputHeader(req, resp)
  local trace = req:getTracer()

  local queryParams = Utils.getQueryParameters(req)
  local path = req:getRequestPath()

  -- only allow calls to the countries service
  if path == nil then
    trace:error("path is nil")
  end 

  if path ~= nil and path ~= '/resource/utility/api/v1/countries' then
    trace:info("utility service called with invalid path " .. path)
    resp:send(404)
    return
  end

  -- only alloq one query-parameter 'lang' with the values DE, FR, IT, EN, RS
  for param, values in pairs(queryParams) do
    if (param ~= 'lang') then
      trace:info("utility service called with invalid query param " .. param)
      resp:send(404)
      return
    end
    if Helpers.tableLength(values) ~= 1 then
      trace:info("utility service called with invalid value for query param " .. param)
      resp:send(404)
      return
    end
    for i, value in pairs(values) do
      local lang = string.upper(value)
      if not ('DE' == lang or 'FR' == lang or 'IT' == lang or 'EN' == lang or 'RS' == lang) then
        trace:info("utility service called with invalid value for query param " .. param .. "=" .. value)
        resp:send(404)
        return
      end
    end
  end
end
